/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of Connection.xs. Do not edit this file, edit Connection.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "xs/Connection.xs"
/*
 *  Copyright 2009 10gen, Inc.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#include "perl_mongo.h"
#include "mongo_link.h"

static int
connection_free (pTHX_ SV *sv, MAGIC *mg)
{
    mongo_link *link;

    PERL_UNUSED_ARG(sv);

    link = (mongo_link *)mg->mg_ptr;

    if (!link->copy && link->master) {
        if (link->master->host) {
            Safefree(link->master->host);
        }

        Safefree(link->master);
    }

    Safefree(link);

    mg->mg_ptr = NULL;

    return 0;
}

static int
connection_clone (pTHX_ MAGIC *mg, CLONE_PARAMS *params)
{
    mongo_link *link, *new_link;

    PERL_UNUSED_ARG (params);

    link = (mongo_link *)mg->mg_ptr;

    Newx(new_link, 1, mongo_link);
    Copy(link, new_link, 1, mongo_link);

    if (link->master) {
        mongo_server *new_master;

        Newx(new_master, 1, mongo_server);
        new_master->host = savepv(link->master->host);
        new_master->port = link->master->port;

        /* Start out disconnected. When we have something to send, we'll
         * reconnect automatically.
         *
         * If we actually wanted to reconnect here, we'd have to make mongo_link
         * carry around a backref to the SV it's associated with so we could
         * reconnect through perl space.
         */
        new_master->connected = 0;

        new_link->master = new_master;
    }


    mg->mg_ptr = (char *)new_link;

    return 0;
}

MGVTBL connection_vtbl = {
    NULL,
    NULL,
    NULL,
    NULL,
    connection_free,
#if MGf_COPY
    NULL,
#endif
#if MGf_DUP
    connection_clone,
#endif
#if MGf_LOCAL
    NULL,
#endif
};

#line 108 "xs/Connection.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 160 "xs/Connection.c"

XS(XS_MongoDB__Connection__init_conn); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection__init_conn)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "self, host, port");
    {
	SV *	self = ST(0);
	char *	host = (char *)SvPV_nolen(ST(1));
	int	port = (int)SvIV(ST(2));
#line 108 "xs/Connection.xs"
    SV *auto_reconnect_sv = 0, *timeout_sv = 0;
    mongo_link *link;
#line 179 "xs/Connection.c"
#line 111 "xs/Connection.xs"
    Newx(link, 1, mongo_link);
    perl_mongo_attach_ptr_to_instance(self, link, &connection_vtbl);

    /*
     * hosts are of the form:
     * [{host => "host", port => 27017}, ...]
     */
    Newx(link->master, 1, mongo_server);
    Newxz(link->master->host, strlen(host)+1, char);
    memcpy(link->master->host, host, strlen(host));
    link->master->port = port;
    link->master->connected = 0;

    auto_reconnect_sv = perl_mongo_call_reader (ST(0), "auto_reconnect");
    timeout_sv = perl_mongo_call_reader (ST(0), "timeout");

    link->auto_reconnect = SvIV(auto_reconnect_sv);
    link->timeout = SvIV(timeout_sv);
    link->copy = 0;

#line 201 "xs/Connection.c"
#line 132 "xs/Connection.xs"
    SvREFCNT_dec (auto_reconnect_sv);
    SvREFCNT_dec (timeout_sv);
#line 205 "xs/Connection.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_MongoDB__Connection__init_conn_holder); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection__init_conn_holder)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, master");
    {
	SV *	self = ST(0);
	SV *	master = ST(1);
#line 140 "xs/Connection.xs"
    mongo_link *self_link, *master_link;
#line 226 "xs/Connection.c"
#line 142 "xs/Connection.xs"
    Newx(self_link, 1, mongo_link);
    perl_mongo_attach_ptr_to_instance(self, self_link, &connection_vtbl);

    master_link = (mongo_link*)perl_mongo_get_ptr_from_instance(master, &connection_vtbl);

    self_link->master = master_link->master;
    self_link->copy = 1;
#line 235 "xs/Connection.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_MongoDB__Connection_connect); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection_connect)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
#line 155 "xs/Connection.xs"
     mongo_link *link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);
     SV *username, *password;
#line 256 "xs/Connection.c"
#line 158 "xs/Connection.xs"
     link->master->socket = perl_mongo_connect(link->master->host, link->master->port, link->timeout);
     link->master->connected = link->master->socket != -1;

     if (!link->master->connected) {
       croak ("couldn't connect to server %s:%d", link->master->host, link->master->port);
     }

     // try authentication
     username = perl_mongo_call_reader (self, "username");
     password = perl_mongo_call_reader (self, "password");

     if (SvPOK(username) && SvPOK(password)) {
       SV *database, *result, **ok;

       database = perl_mongo_call_reader (self, "db_name");
       result = perl_mongo_call_method(self, "authenticate", 0, 3, database, username, password);
       if (!result || SvTYPE(result) != SVt_RV) {
         if (result && SvPOK(result)) {
           croak("%s", SvPV_nolen(result));
         }
         else { 
           sv_dump(result);
           croak("something weird happened with authentication");
         }
       }

       ok = hv_fetch((HV*)SvRV(result), "ok", strlen("ok"), 0);
       if (!ok || 1 != SvIV(*ok)) {
         SvREFCNT_dec(database);
         SvREFCNT_dec(username);
         SvREFCNT_dec(password);

         croak ("couldn't authenticate with server");
       }

       SvREFCNT_dec(database);
     }

     SvREFCNT_dec(username);
     SvREFCNT_dec(password);
#line 298 "xs/Connection.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_MongoDB__Connection_connected); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection_connected)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
	int	RETVAL;
	dXSTARG;
#line 204 "xs/Connection.xs"
     mongo_link *link;
#line 320 "xs/Connection.c"
#line 206 "xs/Connection.xs"
     link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);

     if (link->master && link->master->connected) {
         RETVAL = 1;
     }
     else {
         RETVAL = 0;
     }
#line 330 "xs/Connection.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_MongoDB__Connection_send); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection_send)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, str");
    {
	SV *	self = ST(0);
	SV *	str = ST(1);
#line 223 "xs/Connection.xs"
         buffer buf;
         STRLEN len;
#line 353 "xs/Connection.c"
	int	RETVAL;
	dXSTARG;
#line 226 "xs/Connection.xs"
         buf.start = SvPV(str,len);
         buf.pos = buf.start+len;
         buf.end = buf.start+len;
#line 360 "xs/Connection.c"
#line 230 "xs/Connection.xs"
         RETVAL = mongo_link_say(self, &buf);
         if (RETVAL == -1) {
           die("can't get db response, not connected");
         }
#line 366 "xs/Connection.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_MongoDB__Connection_recv); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection_recv)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, cursor");
    {
	SV *	cursor = ST(1);
#line 242 "xs/Connection.xs"
         mongo_link_hear(cursor);
#line 387 "xs/Connection.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_MongoDB__Connection_DEMOLISH); /* prototype to pass -Wmissing-prototypes */
XS(XS_MongoDB__Connection_DEMOLISH)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, in_global_destruction");
    {
	SV *	self = ST(0);
#line 249 "xs/Connection.xs"
         mongo_link *link;
#line 407 "xs/Connection.c"
#line 251 "xs/Connection.xs"
         link = (mongo_link*)perl_mongo_get_ptr_from_instance(self, &connection_vtbl);

         if (!link->copy && link->master) {
           set_disconnected(self);
         }
#line 414 "xs/Connection.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_MongoDB__Connection); /* prototype to pass -Wmissing-prototypes */
XS(boot_MongoDB__Connection)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("MongoDB::Connection::_init_conn", XS_MongoDB__Connection__init_conn, file);
        newXS("MongoDB::Connection::_init_conn_holder", XS_MongoDB__Connection__init_conn_holder, file);
        newXS("MongoDB::Connection::connect", XS_MongoDB__Connection_connect, file);
        newXS("MongoDB::Connection::connected", XS_MongoDB__Connection_connected, file);
        newXS("MongoDB::Connection::send", XS_MongoDB__Connection_send, file);
        newXS("MongoDB::Connection::recv", XS_MongoDB__Connection_recv, file);
        newXS("MongoDB::Connection::DEMOLISH", XS_MongoDB__Connection_DEMOLISH, file);
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

